import { IObservable } from "jalhyd";

import { FormulaireBase } from "./form-base";
import { FieldSet } from "../../fieldset";

/**
 * Formulaire pour Lechapt et Calmon
 */
export class FormulaireLechaptCalmon extends FormulaireBase {

    /** id of select configuring material */
    private _lcMaterialSelectId: string;

    protected parseOptions(json: {}) {
        super.parseOptions(json);
        this._lcMaterialSelectId = this.getOption(json, "lcMaterialSelectId");
    }

    public afterParseFieldset(fs: FieldSet) {
        if (this._lcMaterialSelectId) {
            const sel = fs.getFormulaireNodeById(this._lcMaterialSelectId);
            if (sel) {
                fs.properties.addObserver(this);
            }
        }
    }

    // interface Observer

    public update(sender: IObservable, data: any) {
        super.update(sender, data);
        if (data.action === "propertyChange") {
            if (data.name === "material") {
                this.reset();
            }
        }
    }
}
