import { NgParameter } from "./formulaire/ngparam";
import { ServiceFactory } from "./services/service-factory";

import { formattedValue } from "jalhyd";

export function logObject(obj: {}, m?: string) {
    // évite le message "Value below was evaluated just now" dans le debugger de Chrome
    if (m === undefined) {
        console.log(JSON.stringify(obj));
    } else {
        console.log(m + " " + JSON.stringify(obj));
    }
}

export function isNumber(s: string): boolean {
    return Number(s) !== NaN;
}

/**
 * Proxy to jaLhyd.formattedValue() using number of digits from app preferences
 */
export function fv(p: NgParameter | number): string {
    let value: number;
    if (p instanceof NgParameter) {
        value = p.getValue();
    } else if (typeof p === "number") {
        value = p;
    }
    const nDigits = ServiceFactory.instance.applicationSetupService.displayPrecision;

    return formattedValue(value, nDigits);
}

/**
 * Trick to decode HTML entities in a string
 * https://stackoverflow.com/a/7394787/5986614
 * @param html string containing HTML entities, like &nbsp;
 */
export function decodeHtml(html: string): string {
    const txt = document.createElement("textarea");
    txt.innerHTML = html;
    return txt.value;
}
